Bug 1426785

Summary: Review Request: pyjokes - One line jokes for programmers (jokes as a service)
Product: [Fedora] Fedora Reporter: Paul Whalen <pwhalen>
Component: Package ReviewAssignee: Peter Robinson <pbrobinson>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: ishcherb, package-review, pbrobinson
Target Milestone: ---Flags: pbrobinson: fedora-review+
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2017-07-01 15:35:41 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Comment 1 Raphael Groner 2017-03-02 01:00:05 UTC
Some general hints:
- It's mandatory to use the %python_provide macro. (MUST)
https://fedoraproject.org/wiki/Packaging:Python#The_.25python_provide_macro
- Why disable tests execution? It's nice to have some running tests, e.g. in case of any possible rebuilds to automatically ensure basic functionality. (SHOULD)

Comment 2 Raphael Groner 2017-03-02 01:01:39 UTC
Please also tell us what's your active FAS account you want to use for packaging.

Comment 3 Peter Robinson 2017-03-02 15:51:15 UTC
(In reply to Raphael Groner from comment #2)
> Please also tell us what's your active FAS account you want to use for
> packaging.

I think that's easy enough to discern based on the fedorapeople URL ;-)

Comment 4 Paul Whalen 2017-03-06 19:54:13 UTC
fas: pwhalen

* Added %python_provide macro, minor spec adjustments.
* Tests currently disabled as some fail, engaging upstream.

SPEC: https://pwhalen.fedorapeople.org/packages/pyjokes.spec
SRPM: https://pwhalen.fedorapeople.org/packages/pyjokes-0.5.0-2.fc25.src.rpm

Comment 5 Peter Robinson 2017-04-08 11:13:16 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "*No copyright* CC by-sa (v3.0)", "Unknown or
     generated", "*No copyright* BSD (unspecified)". 20 files have unknown
     license. Detailed output of licensecheck in
     /home/peter/1426785-pyjokes/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python2.7/site-packages/pyjokes,
     /usr/lib/python3.5/site-packages/pyjokes
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python2.7/site-
     packages/pyjokes, /usr/lib/python3.5/site-packages/pyjokes
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 552960 bytes in 12 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-pyjokes , python3-pyjokes
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-pyjokes-0.5.0-2.fc25.noarch.rpm
          python3-pyjokes-0.5.0-2.fc25.noarch.rpm
          pyjokes-0.5.0-2.fc25.src.rpm
0 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
python3-pyjokes (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)

python2-pyjokes (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)



Provides
--------
python3-pyjokes:
    python3-pyjokes
    python3.5dist(pyjokes)
    python3dist(pyjokes)

python2-pyjokes:
    python-pyjokes
    python2-pyjokes
    python2.7dist(pyjokes)
    python2dist(pyjokes)



Source checksums
----------------
https://github.com/pyjokes/pyjokes/archive/v0.5.0.tar.gz :
  CHECKSUM(SHA256) this package     : 490fc6504a0298ad7575be3af559644ceb4837e834e820c17b4727847c3eb3c5
  CHECKSUM(SHA256) upstream package : 490fc6504a0298ad7575be3af559644ceb4837e834e820c17b4727847c3eb3c5

Comment 6 Peter Robinson 2017-04-08 11:13:42 UTC
Looks fine. Approved

Comment 7 Gwyn Ciesla 2017-04-24 14:38:08 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/pyjoke

Comment 8 Gwyn Ciesla 2017-04-25 15:23:30 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/pyjokes

Comment 9 Fedora Update System 2017-04-30 17:52:04 UTC
pyjokes-0.5.0-2.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-60ad8bdbf6

Comment 10 Fedora Update System 2017-05-02 06:36:19 UTC
pyjokes-0.5.0-2.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-60ad8bdbf6

Comment 11 Iryna Shcherbina 2017-05-02 12:22:54 UTC
The python2-pyjokes RPM requires both Python 2 and Python 3.

$ dnf --enablerepo=rawhide repoquery --requires python2-pyjokes
/usr/bin/python3
python(abi) = 2.7

Except in very special circumstances, there is no need for one package
to drag in both Python stacks. Usually, this is a packaging error, in this
case a Python 3 built executable is installed in a Python 2 subpackage.

According to the Packaging Guidelines [0], if the executable should generate 
the same output regardless of whether it is built with Python 2 or Python 3, 
then only the Python 3 version of the executable should be packaged. 
I believe this is the case for `/usr/bin/pyjoke`, so please install it only 
in the Python 3 subpackage. There is a section on `%install` in the 
Python RPM Porting Guide [1] which covers this issue. 

It's ok to do this in Rawhide only, however, it would be greatly
appreciated if you could push it to Fedora 25 as well.


If anything is unclear, or if you need any kind of assistance, you can
ask on IRC (#fedora-python on Freenode), or reply here.

[0] https://fedoraproject.org/wiki/Packaging:Python#Avoiding_collisions_between_the_python_2_and_python_3_stacks
[1] http://python-rpm-porting.readthedocs.io/en/latest/application-modules.html#install

Comment 12 Fedora Update System 2017-05-11 14:53:12 UTC
pyjokes-0.5.0-3.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-eb1ff4415e